stages:
    -   lint
    -   build
    -   trigger

variables:
    DOCKERHUB_USERNAME: "bengt"
    DOCKERHUB_REGISTRY: "docker.io"
    DOCKERHUB_REGISTRY_IMAGE: "index.docker.io/bengt/GridGAN"

lint-python3.7:
    image: hadolint/hadolint:latest-debian
    script:
        - hadolint python3.7/Dockerfile --ignore DL3008
    stage:
        lint

lint-python3.7-rocm:
    image: hadolint/hadolint:latest-debian
    script:
        - hadolint python3.7-rocm/Dockerfile --ignore DL3008
    stage:
        lint

lint-python3.8:
    image: hadolint/hadolint:latest-debian
    script:
        - hadolint python3.8/Dockerfile --ignore DL3008
    stage:
        lint

lint-python3.8-rocm:
    image: hadolint/hadolint:latest-debian
    script:
        - hadolint python3.8-rocm/Dockerfile --ignore DL3008
    stage:
        lint

lint-python3.9:
    image: hadolint/hadolint:latest-debian
    script:
        - hadolint python3.9/Dockerfile --ignore DL3008
    stage:
        lint

lint-python3.9-rocm:
    image: hadolint/hadolint:latest-debian
    script:
        - hadolint python3.9-rocm/Dockerfile --ignore DL3008
    stage:
        lint

python3.7:
    image:
        name: gcr.io/kaniko-project/executor:debug
        entrypoint: [ "" ]
    needs: ["lint-python3.7"]
    script:
        -   mkdir -p /kaniko/.docker
        -   echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
        -   /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/python3.7/Dockerfile --destination $CI_REGISTRY_IMAGE:python3.7-latest
    stage: build

python3.7-rocm:
    image:
        name: gcr.io/kaniko-project/executor:debug
        entrypoint: [ "" ]
    needs: ["lint-python3.7-rocm"]
    script:
        -   mkdir -p /kaniko/.docker
        -   echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
        -   /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/python3.7-rocm/Dockerfile --destination $CI_REGISTRY_IMAGE:python3.7-rocm-latest
    stage: build

python3.8:
    image:
        name: gcr.io/kaniko-project/executor:debug
        entrypoint: [ "" ]
    needs: ["lint-python3.8"]
    script:
        -   mkdir -p /kaniko/.docker
        -   echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
        -   /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/python3.8/Dockerfile --destination $CI_REGISTRY_IMAGE:python3.8-latest
    stage: build

python3.8-rocm:
    image:
        name: gcr.io/kaniko-project/executor:debug
        entrypoint: [ "" ]
    needs: ["lint-python3.8-rocm"]
    script:
        -   mkdir -p /kaniko/.docker
        -   echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
        -   /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/python3.8-rocm/Dockerfile --destination $CI_REGISTRY_IMAGE:python3.8-rocm-latest
    stage: build

python3.9:
    image:
        name: gcr.io/kaniko-project/executor:debug
        entrypoint: [ "" ]
    needs: ["lint-python3.9"]
    script:
        -   mkdir -p /kaniko/.docker
        -   echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
        -   /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/python3.9/Dockerfile --destination $CI_REGISTRY_IMAGE:python3.9-latest
    stage: build

python3.9-rocm:
    image:
        name: gcr.io/kaniko-project/executor:debug
        entrypoint: [ "" ]
    needs: ["lint-python3.9-rocm"]
    script:
        -   mkdir -p /kaniko/.docker
        -   echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
        -   /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/python3.9-rocm/Dockerfile --destination $CI_REGISTRY_IMAGE:python3.9-rocm-latest
    stage: build

trigger:
    image: curlimages/curl
    needs: ["python3.7", "python3.8", "python3.9"]
    script:
        # Trigger Modeler
        -   curl --silent -X POST
            -F token=4276786a083e7bdc3395a7f6139817
            -F ref=master
             https://gitlab.com/api/v4/projects/18502968/trigger/pipeline
        # Trigger Sampler
        -   curl --silent -X POST
            -F token=0b22e8122ec2e6dcc6ea94959f4ce8
            -F ref=master
             https://gitlab.com/api/v4/projects/18505836/trigger/pipeline
        # Trigger Heuristic
        -   curl --silent -X POST
            -F token=0856b5be65e56cd7a371f475ed0c08
            -F ref=master
             https://gitlab.com/api/v4/projects/12164698/trigger/pipeline
    stage: trigger

trigger-rocm:
    image: curlimages/curl
    needs: ["python3.7-rocm", "python3.8-rocm", "python3.9-rocm"]
    script:
        # Trigger Trainer
        -   curl --silent -X POST
            -F token=7f9b8d94cf3a2a4324582b08999a79
            -F ref=master
            https://gitlab.com/api/v4/projects/18502968/trigger/pipeline
        # Trigger Decoder
        -   curl --silent -X POST
            -F token=7f9b8d94cf3a2a4324582b08999a79
            -F ref=master
            https://gitlab.com/api/v4/projects/18502968/trigger/pipeline
    stage: trigger
